/*******************************************************************************
* Copyright (C) NEC Electronics Corporation 2008
* NEC ELECTRONICS CONFIDENTIAL AND PROPRIETARY
* All rights reserved by NEC Electronics Corporation.
* Use of copyright notice does not evidence publication
*
*  File Name : include/serial.h
*  Contents  : serial header
*  History   :
*   Date        Rev.      Who         Details     Keyword
*  ==========  ========  ==========  ==========  ==========
*  2009/8/19   Rev1.01   j-nakamu
*
*******************************************************************************/

#ifndef __SERIAL_H
#define __SERIAL_H

/* UART register */
#define EM1_UART0_BASE		0x50000000

#define UART0_THR			(EM1_UART0_BASE + 0x00)
#define UART0_IER			(EM1_UART0_BASE + 0x04)
#define UART0_FCR			(EM1_UART0_BASE + 0x0c)
#define UART0_LCR			(EM1_UART0_BASE + 0x10)
#define UART0_MCR			(EM1_UART0_BASE + 0x14)
#define UART0_LSR			(EM1_UART0_BASE + 0x18)
#define UART0_DLL			(EM1_UART0_BASE + 0x24)
#define UART0_DLM			(EM1_UART0_BASE + 0x28)

#define EM1_UART1_BASE		(EM1_UART0_BASE + 0x10000)

#define UART1_THR			(EM1_UART1_BASE + 0x00)
#define UART1_IER			(EM1_UART1_BASE + 0x04)
#define UART1_FCR			(EM1_UART1_BASE + 0x0c)
#define UART1_LCR			(EM1_UART1_BASE + 0x10)
#define UART1_MCR			(EM1_UART1_BASE + 0x14)
#define UART1_LSR			(EM1_UART1_BASE + 0x18)
#define UART1_DLL			(EM1_UART1_BASE + 0x24)
#define UART1_DLM			(EM1_UART1_BASE + 0x28)


/* baudrate 115200bps for U70SCLK=229.376MHz */
#define UART_DLL_115200			0x1F
#define UART_DLM_115200			0x00

#define UART_LCR_DLAB			0x80
#define UART_LCR_WLEN8			0x03

#define UART_MCR_RTS			0x02
#define UART_MCR_DTR			0x01

#define UART_FCR_FIFO_ENABLE	0x01
#define UART_FCR_FIFO_RESET		0x07

#define UART_IER_CLR			0x00

/* Tx Buffer empty */
#define UART_LSR_THRE			0x20

#endif /* __SERIAL_H */
