/*
 * (C) Copyright 2008
 * NEC Electronics Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __CONFIG_H
#define __CONFIG_H

#define LOCAL_MODIFICATION

#if defined(CONFIG_MP200_EMMCBOOT) || defined(CONFIG_MP200_SDBOOT)
#define CONFIG_SKIP_RELOCATE_UBOOT
#if defined(CONFIG_EM1_BOARD_DKIT)
#define CONFIG_MP200_EMMC_1Piece	1	/* 0:eMMC 2pieces 1:eMMC 1piece */
#else
#define CONFIG_MP200_EMMC_1Piece	0	/* 0:eMMC 2pieces 1:eMMC 1piece */
#endif
#endif

/*
 * High Level Configuration Options
 * (easy to change)
 */
#define CONFIG_ARM1136		1	/* This is an arm1136 CPU core  */
#define CONFIG_MP200		1	/* MP200 series */
#define CONFIG_MACH_EM1		1

/* "CONFIG_MP200_DDR_1GBit" means DDR 1Gbit(128MByte) is defined from building configuration. */
#ifdef CONFIG_MP200_CHIP_EM1D
#undef CONFIG_MP200_DDR_1GBit
#endif

//#define CONFIG_FAST_BOOT
#undef CONFIG_FAST_BOOT

#define CONFIG_CMDLINE_TAG	/* Enable kernel cmdline */

#undef CONFIG_USE_IRQ		/* we don't need IRQ/FIQ stuff */

/*
 * Size of malloc() pool
 */
#define CFG_MALLOC_LEN		(CFG_ENV_SIZE + 128*1024)
#define CFG_GBL_DATA_SIZE	128	/* size in bytes reserved for initial data */

/*
 * Hardware drivers
 */
#if   defined(CONFIG_EM1_BOARD_DKIT)
#define CONFIG_DRIVER_SMSC9118
#define CONFIG_SMSC9118_BASE	0x20000000
#else
#define CONFIG_DRIVER_SMC91111
#define CONFIG_SMC91111_BASE	0x20000300
#endif

/*
 * NS16550 Configuration
 */
#define CFG_NS16550
#define CFG_NS16550_SERIAL
#define CFG_NS16550_REG_SIZE	(-4)
#ifdef CONFIG_MP200_PLL3_238MHZ
#define CFG_NS16550_CLK			(237568000/2)	/* PLL3(237.567MHz) divided by 2 */
#else
#define CFG_NS16550_CLK			(229376000/2)	/* PLL3(229.376MHz) divided by 2 */
#endif
#define CFG_NS16550_COM_BASE		0x50000000
#ifdef LOCAL_MODIFICATION
#define CFG_NS16550_COM2		(CFG_NS16550_COM_BASE + 0x10000)
#else
#define CFG_NS16550_COM1		(CFG_NS16550_COM_BASE + 0x00000)
#endif

/*
 * select serial console configuration
 */
#define CONFIG_ENV_OVERWRITE
#ifdef LOCAL_MODIFICATION
#define CONFIG_CONS_INDEX	2
#else
#define CONFIG_CONS_INDEX	1
#endif
#define CONFIG_BAUDRATE		115200
#define CFG_BAUDRATE_TABLE	{ 57600, 115200 }

#define CONFIG_COMMANDS	(CONFIG_CMD_DFL | CFG_CMD_PING)

#define CONFIG_DISPLAY_BOARDINFO

/* this must be included AFTER the definition of CONFIG_COMMANDS (if any) */
#include <cmd_confdefs.h>

#ifdef CONFIG_FAST_BOOT
#define CONFIG_BOOTDELAY	0
#else
#ifdef LOCAL_MODIFICATION
//#define CONFIG_BOOTDELAY	5
#define CONFIG_BOOTDELAY	1
#else
#define CONFIG_BOOTDELAY	3
#endif
#endif /* CONFIG_FAST_BOOT */

#if defined(CONFIG_MP200_EMMCBOOT)
#define CONFIG_EXT3_ROOT	"/dev/mmcblk0p3"	/* emmc-boot */
#elif CONFIG_MP200_EMMC_1Piece
#define CONFIG_EXT3_ROOT	"/dev/mmcblk1p3"	/* sd-boot (emmc 1 device) */
#else
#define CONFIG_EXT3_ROOT	"/dev/mmcblk2p3"	/* sd-boot (emmc 2 device) */
#endif

#ifdef CONFIG_MP200_DDR_1GBit	/* defined DDR 1Gbit(128MByte) */
#define CONFIG_DDR			"mem=32M@0x30000000 mem=32M@0x34000000 mem=32M@0x36000000"	/* 96MByte */

#ifdef LOCAL_MODIFICATION
#define CONFIG_BOOTARGS		"root=/dev/null noinitrd init=/linuxrc console=ttyS1,115200n8n SELINUX_INIT=no mem=32M@0x30000000 mem=32M@0x34000000 mem=32M@0x36000000 ro video=qfb: ip=none rootflags=physaddr=0x00400000"
#else
#define CONFIG_BOOTARGS		"root=/dev/null noinitrd init=/linuxrc console=ttyS0,115200n8n SELINUX_INIT=no mem=32M@0x30000000 mem=32M@0x34000000 mem=32M@0x36000000 ro video=qfb: ip=none rootflags=physaddr=0x00400000"
#endif
#else
#define CONFIG_DDR			"mem=32M@0x30000000"	/* 32MByte */

#ifdef LOCAL_MODIFICATION
#define CONFIG_BOOTARGS		"root=/dev/null noinitrd init=/linuxrc console=ttyS1,115200n8n SELINUX_INIT=no mem=32M@0x30000000 ro video=qfb: ip=none rootflags=physaddr=0x00400000"
#else
#define CONFIG_BOOTARGS		"root=/dev/null noinitrd init=/linuxrc console=ttyS0,115200n8n SELINUX_INIT=no mem=32M@0x30000000 ro video=qfb: ip=none rootflags=physaddr=0x00400000"
#endif
#endif
#ifdef LOCAL_MODIFICATION
// eflow-changed
//#define CONFIG_CRAMFSCMD	"setenv bootargs root=/dev/null noinitrd init=/linuxrc console=ttyS1,115200n8n SELINUX_INIT=no \$(cfg_ddr) ro video=qfb: ip=none rootflags=physaddr=0x00400000\;bootm 00080000"
#define CONFIG_CRAMFSCMD	"setenv bootargs root=/dev/null noinitrd init=/linuxrc udevtimeout=1 console=ttyS1,115200n8n SELINUX_INIT=no \$(cfg_ddr) ro video=qfb: ip=none rootflags=physaddr=0x00400000\;bootm 00080000"
#define CONFIG_CRAMFSCMD2	"setenv bootargs root=/dev/null noinitrd init=/linuxrc udevtimeout=1 console=ttyS1,115200n8n SELINUX_INIT=no \$(cfg_ddr) ro video=qfb: ip=none rootflags=physaddr=0x01800000\;bootm 01500000"
#define CONFIG_NFSCMD		"setenv bootargs root=/dev/nfs noinitrd init=/linuxrc console=ttyS1,115200n8n SELINUX_INIT=no \$(cfg_ddr) ro video=qfb: nfsroot=\$(serverip):\$(rootpath),timeo=30 ip=\$(ipaddr):\$(serverip):\$(gatewayip):\$(netmask):\$(hostname):eth0:off\;bootm 00080000"
#ifdef CONFIG_MP200_SDBOOT_LINE	/* SD boot linesystem */
#define CONFIG_EXT3CMD		"setenv bootargs root=/dev/null noinitrd init=/linuxrc console=ttyS1,115200n8n SELINUX_INIT=no mem=32M@0x30000000 rw video=qfb: ip=none rootflags=physaddr=0x34000000\;bootm 30007fc0"
#else
#define CONFIG_EXT3CMD		"setenv bootargs root=\$(ext3_root) noinitrd init=/linuxrc console=ttyS1,115200n8n SELINUX_INIT=no \$(cfg_ddr) rw video=qfb: ip=none rootfstype=ext3 rootwait\;bootm 30007fc0"
#endif
#else
#define CONFIG_CRAMFSCMD	"setenv bootargs root=/dev/null noinitrd init=/linuxrc console=ttyS0,115200n8n SELINUX_INIT=no \$(cfg_ddr) ro video=qfb: ip=none rootflags=physaddr=0x00400000\;bootm 00080000"
#define CONFIG_NFSCMD		"setenv bootargs root=/dev/nfs noinitrd init=/linuxrc console=ttyS0,115200n8n SELINUX_INIT=no \$(cfg_ddr) ro video=qfb: nfsroot=\$(serverip):\$(rootpath),timeo=30 ip=\$(ipaddr):\$(serverip):\$(gatewayip):\$(netmask):\$(hostname):eth0:off\;bootm 00080000"
#ifdef CONFIG_MP200_SDBOOT_LINE	/* SD boot linesystem */
#define CONFIG_EXT3CMD		"setenv bootargs root=/dev/null noinitrd init=/linuxrc console=ttyS0,115200n8n SELINUX_INIT=no mem=32M@0x30000000 rw video=qfb: ip=none rootflags=physaddr=0x34000000\;bootm 30007fc0"
#else
#define CONFIG_EXT3CMD		"setenv bootargs root=\$(ext3_root) noinitrd init=/linuxrc console=ttyS0,115200n8n SELINUX_INIT=no \$(cfg_ddr) rw video=qfb: ip=none rootfstype=ext3 rootwait\;bootm 30007fc0"
#endif
#endif

#define CFG_LOAD_ADDR		0x30007fc0	/* default load address */
#if defined(CONFIG_MP200_EMMCBOOT) || defined(CONFIG_MP200_SDBOOT)
#define CONFIG_BOOTCOMMAND	"run ext3cmd"
#else
#define CONFIG_BOOTCOMMAND	"run cramfscmd"
#define CONFIG_BOOTCOMMAND2	"run cramfscmd2"
#endif

#define CONFIG_IPADDR		192.168.1.100
#define CONFIG_SERVERIP		192.168.1.1
#define CONFIG_BOOTFILE		uImage

/*
 * Miscellaneous configurable options
 */
#define CFG_LONGHELP		/* undef to save memory     */
#define CFG_PROMPT			"EM1 # "	/* Monitor Command Prompt   */
#define CFG_CBSIZE			384			/* Console I/O Buffer Size  */
/* Print Buffer Size */
#define CFG_PBSIZE			(CFG_CBSIZE+sizeof(CFG_PROMPT)+16)
#define CFG_MAXARGS			24			/* max number of command args   */
#define CFG_BARGSIZE		CFG_CBSIZE	/* Boot Argument Buffer Size    */

#define CFG_MEMTEST_START	0x33000000	/* memtest works on */
#define CFG_MEMTEST_END		0x33ffffff	/* 64 MB in DRAM    */

/* MEM TEST */
#define CFG_ALT_MEMTEST     1

#undef	CFG_CLKS_IN_HZ		/* everything, incl board info, in Hz */

/* The 1610 has 6 timers, they can be driven by the RefClk (12Mhz) or by
 * DPLL1. This time is further subdivided by a local divisor.
 */
#define CFG_TIMERBASE		0xc0000000	/* use timer 1 */
#define CFG_HZ				32768

/*-----------------------------------------------------------------------
 * Stack sizes
 *
 * The stack sizes are set up in start.S using the settings below
 */
#define CONFIG_STACKSIZE		(128*1024)	/* regular stack */
#ifdef CONFIG_USE_IRQ
#define CONFIG_STACKSIZE_IRQ	(4*1024)	/* IRQ stack */
#define CONFIG_STACKSIZE_FIQ	(4*1024)	/* FIQ stack */
#endif

/*-----------------------------------------------------------------------
 * Physical Memory Map
 */
#ifdef CONFIG_MP200_DDR_1GBit	/* defined DDR 1Gbit(128MByte) */
#define PHYS_SDRAM_SIZE			0x04000000	/* 64 MB */
#else
#define PHYS_SDRAM_SIZE			0x02000000	/* 32 MB */
#endif
#define PHYS_SDRAM_1			0x30000000							/* SDRAM Bank #1 */
#define PHYS_SDRAM_1_SIZE		PHYS_SDRAM_SIZE
#define PHYS_SDRAM_2			(PHYS_SDRAM_1 + PHYS_SDRAM_1_SIZE)	/* SDRAM Bank #2 */
#define PHYS_SDRAM_2_SIZE		PHYS_SDRAM_SIZE
#define CONFIG_NR_DRAM_BANKS	2			/* we have 2 bank of DRAM */

#define PHYS_FLASH_1			0x00000000	/* FLASH Bank #1 */
#define PHYS_FLASH_2			0x02000000	/* FLASH Bank #2 */
#define CFG_FLASH_BASE			PHYS_FLASH_1
#define CFG_MAX_FLASH_BANKS		1			/* max number of memory banks */
#define CFG_MAX_FLASH_SECT		(255 + 4)		/* max number of sectors on one chip */

/* timeout values are in ticks */
#define CFG_FLASH_ERASE_TOUT	(20*CFG_HZ)	/* Timeout for Flash Erase */
#define CFG_FLASH_WRITE_TOUT	(20*CFG_HZ)	/* Timeout for Flash Write */

/*-----------------------------------------------------------------------
 * SRAM
 */
#define	SRAM_HWINFO_BOOT		(0xa001ff00)
#define	SRAM_HWINFO_KERNL		(0xa001fffc)

/*-----------------------------------------------------------------------
 * FLASH and environment organization
 */

#define CFG_ENV_IS_IN_FLASH		1

#define CFG_ENV_SIZE			0x00040000	/* Total Size of Environment Sector */
#define CFG_ENV_OFFSET			0x00040000	/* environment starts here  */
#define CFG_ENV_ADDR			(CFG_FLASH_BASE + CFG_ENV_OFFSET)


#ifdef CONFIG_MP200_EMMCBOOT
/* addr of environment */
#define CFG_ENV_IS_IN_EMMC

#define CFG_EMMC_BANKS			1				/* number of memory banks */
#define CFG_EMMC_BLOCKS			0x800000		/* number of memory blocks */
#define CFG_EMMC_SECT_OF_BLOCKS	0x1000			/* 1[sector] == 4096[block] * 512[byte] */
#define CFG_EMMC_SECTS			(CFG_EMMC_BLOCKS / CFG_EMMC_SECT_OF_BLOCKS)	/* 0x2000[bank] */

#define CFG_EMMC_PROTECT_TBL	0xa0000000		/* protect table address */
#define CFG_EMMC_PROTECT_SIZE	CFG_EMMC_SECTS	/* protect table size (0x800[byte]) */

#define CFG_ENV_EMMC_OFFSET		0x200			/* environment starts p1 + here  */
#define CFG_ENV_TMP_ADDR		0x310C0000		/* 0x310C0000 - 0x310FFFFF */
#endif	/* CONFIG_MP200_EMMCBOOT */


#ifdef CONFIG_MP200_SDBOOT
/* addr of environment */
#define CFG_ENV_IS_IN_SD

#define CFG_SD_BANKS			1				/* number of memory banks */
#define CFG_SD_SECT_OF_BLOCKS	0x100			/* 1[sector] == 256[block] * 512[byte] */

#define CFG_SD_PROTECT_TBL		0xa0000000		/* protect table address */

#define CFG_ENV_SD_OFFSET		0x0				/* environment starts p2 + here  */
#define CFG_ENV_TMP_ADDR		0x310C0000		/* 0x310C0000 - 0x310FFFFF */
#endif	/* CONFIG_MP200_SDBOOT */


#if 0
/* NAND */
#define CFG_NAND_BASE			0x10000000
#define CFG_NAND_DATA_BASE		CFG_NAND_BASE
#define CFG_NAND_COMMAND_BASE	0x10020000
#define CFG_NAND_ADDRESS_BASE	0x10040000

#define CFG_MAX_NAND_DEVICE			1
#define NAND_MAX_CHIPS				1
#endif

/*-----------------------------------------------------------------------*/

#ifdef CONFIG_FAST_BOOT
#define CONFIG_SILENT_CONSOLE   1              /* Set Silent Mode */
#define CONFIG_EXTRA_ENV_SETTINGS "silent=1\0" /* Set "silent" at "1" */
#endif /* CONFIG_FAST_BOOT */

#define CONFIG_EXTRA_ENV_SETTINGS	\
	"cramfscmd="	CONFIG_CRAMFSCMD			"\0"	\
	"cramfscmd2="	CONFIG_CRAMFSCMD2			"\0"	\
	"ext3cmd="		CONFIG_EXT3CMD				"\0"	\
	"nfscmd="		CONFIG_NFSCMD				"\0"	\
	"cfg_ddr="		CONFIG_DDR					"\0"	\
	"ext3_root="	CONFIG_EXT3_ROOT			"\0"
#endif	/* __CONFIG_H */
